Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 9485)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 9486)
@@ -587,8 +587,8 @@
             form_fields = grok.AutoFields(
                 IUGStudentClearance).omit('clearance_locked')
-        if not getattr(self.context, 'clearance_comment'):
-            form_fields = form_fields.omit('clearance_comment')
-        else:
-            form_fields['clearance_comment'].custom_widget = BytesDisplayWidget
+        if not getattr(self.context, 'officer_comment'):
+            form_fields = form_fields.omit('officer_comment')
+        else:
+            form_fields['officer_comment'].custom_widget = BytesDisplayWidget
         return form_fields
 
@@ -615,6 +615,6 @@
             form_fields = grok.AutoFields(
                 IUGStudentClearance).omit('clearance_locked')
-        if not getattr(self.context, 'clearance_comment'):
-            form_fields = form_fields.omit('clearance_comment')
+        if not getattr(self.context, 'officer_comment'):
+            form_fields = form_fields.omit('officer_comment')
         return form_fields
 
@@ -709,5 +709,5 @@
     grok.require('waeup.clearStudent')
     form_fields = grok.AutoFields(
-        IUGStudentClearance).select('clearance_comment')
+        IUGStudentClearance).select('officer_comment')
 
     @action(_('Save comment and reject clearance now'), style='primary')
@@ -726,5 +726,5 @@
             return
         self.applyData(self.context, **data)
-        comment = data['clearance_comment']
+        comment = data['officer_comment']
         self.context.writeLogMessage(
             self, 'comment: %s' % comment.replace('\n', '<br>'))
@@ -1953,8 +1953,8 @@
         if self.context.is_postgrad:
             form_fields = grok.AutoFields(IPGStudentClearance).omit(
-                'clearance_locked', 'clr_code', 'clearance_comment')
+                'clearance_locked', 'clr_code', 'officer_comment')
         else:
             form_fields = grok.AutoFields(IUGStudentClearance).omit(
-                'clearance_locked', 'clr_code', 'clearance_comment')
+                'clearance_locked', 'clr_code', 'officer_comment')
         return form_fields
 
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/catalog.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/catalog.py	(revision 9485)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/catalog.py	(revision 9486)
@@ -71,5 +71,5 @@
         self.current_session = current_session
         self.certificate = context['studycourse'].certificate
-        self.comment = getattr(context, 'clearance_comment', None)
+        self.comment = getattr(context, 'officer_comment', None)
 
 def search(query=None, searchtype=None, view=None):
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 9485)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 9486)
@@ -274,5 +274,5 @@
         )
 
-    clearance_comment = schema.Text(
+    officer_comment = schema.Text(
         title = _(u"Officer's Comment"),
         required = False,
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 9485)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 9486)
@@ -1212,5 +1212,5 @@
             self.browser.url, self.student_path + '/reject_clearance')
         # Type comment why
-        self.browser.getControl(name="form.clearance_comment").value = """Dear Student,
+        self.browser.getControl(name="form.officer_comment").value = """Dear Student,
 You did not fill properly.
 """
@@ -1231,5 +1231,5 @@
         self.assertTrue('Your message has been sent' in self.browser.contents)
         # The comment has been stored ...
-        self.assertEqual(self.student.clearance_comment,
+        self.assertEqual(self.student.officer_comment,
             u'Dear Student,\nYou did not fill properly.\n')
         # ... and logged
@@ -1267,5 +1267,5 @@
         IWorkflowInfo(self.student).fireTransition('request_clearance')
         IWorkflowInfo(self.student).fireTransition('clear')
-        self.assertEqual(self.student.clearance_comment, None)
+        self.assertEqual(self.student.officer_comment, None)
 
     def test_handle_courses_by_ca(self):
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 9485)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 9486)
@@ -43,12 +43,11 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'adm_code,clearance_comment,clearance_locked,clr_code,'
-            'date_of_birth,email,employer,'
-            'firstname,lastname,matric_number,middlename,nationality,'
+            'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
+            'firstname,lastname,matric_number,middlename,nationality,officer_comment,'
             'perm_address,phone,reg_number,sex,student_id,suspended,password,'
             'state,history,certcode,is_postgrad,current_level,current_session\r\n'
 
-            'my adm code,,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,234,M.,NG,"Studentroad 21\nLagos 123456\n",'
+            'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
+            'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n",'
             '+234-123-12345#,123,f,A111111,0,,created'
             in result
@@ -64,12 +63,11 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'adm_code,clearance_comment,clearance_locked,clr_code,'
-            'date_of_birth,email,employer,'
-            'firstname,lastname,matric_number,middlename,nationality,'
+            'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
+            'firstname,lastname,matric_number,middlename,nationality,officer_comment,'
             'perm_address,phone,reg_number,sex,student_id,suspended,password,'
             'state,history,certcode,is_postgrad,current_level,current_session\r\n'
 
-            'my adm code,,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,234,M.,NG,"Studentroad 21\nLagos 123456\n",'
+            'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
+            'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n",'
             '+234-123-12345#,123,f,A111111,0,,created'
             in result
@@ -84,12 +82,11 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'adm_code,clearance_comment,clearance_locked,clr_code,'
-            'date_of_birth,email,employer,'
-            'firstname,lastname,matric_number,middlename,nationality,'
+            'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
+            'firstname,lastname,matric_number,middlename,nationality,officer_comment,'
             'perm_address,phone,reg_number,sex,student_id,suspended,password,'
             'state,history,certcode,is_postgrad,current_level,current_session\r\n'
 
-            'my adm code,,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,234,M.,NG,"Studentroad 21\nLagos 123456\n",'
+            'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
+            'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n",'
             '+234-123-12345#,123,f,A111111,0,,created'
             in result
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/workflow.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/workflow.py	(revision 9485)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/workflow.py	(revision 9486)
@@ -257,5 +257,5 @@
             level_object.validation_date = datetime.utcnow()
     elif event.transition.transition_id == 'clear':
-        obj.clearance_comment = None
+        obj.officer_comment = None
     elif event.transition.transition_id == 'reset8':
         current_level = obj['studycourse'].current_level