Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py	(revision 9533)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py	(revision 9544)
@@ -55,5 +55,5 @@
 
     create_names = [
-        'firstname', 'lastname',
+        'firstname', 'middlename', 'lastname',
         'sex', 'date_of_birth',
         'email', 'phone'
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_applicantcopier.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_applicantcopier.py	(revision 9533)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_applicantcopier.py	(revision 9544)
@@ -94,4 +94,5 @@
         self.assertEqual(student.email, 'xx@yy.zz')
         self.assertEqual(student.firstname, 'John')
+        self.assertEqual(student.middlename, 'Anthony')
         self.assertEqual(student.lastname, 'Tester')
         # student_id set in application record?
@@ -122,5 +123,5 @@
         self.browser.getControl(name="searchterm").value = 'dep1'
         self.browser.getControl("Search").click()
-        self.assertMatches('...John Tester...', self.browser.contents)
+        self.assertMatches('...John Anthony Tester...', self.browser.contents)
         # Has the student studycourse the correct attributes?
         self.assertEqual(student['studycourse'].certificate.code, 'CERT1')
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 9533)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 9544)
@@ -167,4 +167,5 @@
         # Fill the edit form with suitable values
         self.browser.getControl(name="form.firstname").value = 'John'
+        self.browser.getControl(name="form.middlename").value = 'Anthony'
         self.browser.getControl(name="form.lastname").value = 'Tester'
         self.browser.getControl(name="form.course1").value = ['CERT1']
@@ -236,9 +237,9 @@
         self.browser.getControl(name="searchterm").value = 'John'
         self.browser.getControl("Search").click()
-        self.assertTrue('John Tester' in self.browser.contents)
+        self.assertTrue('John Anthony Tester' in self.browser.contents)
         self.browser.getControl(name="searchtype").value = ['fullname']
         self.browser.getControl(name="searchterm").value = 'Tester'
         self.browser.getControl("Search").click()
-        self.assertTrue('John Tester' in self.browser.contents)
+        self.assertTrue('John Anthony Tester' in self.browser.contents)
         self.browser.open(self.search_path)
         # ... and via his reg_number ...
@@ -246,9 +247,9 @@
         self.browser.getControl(name="searchterm").value = '2345'
         self.browser.getControl("Search").click()
-        self.assertFalse('John Tester' in self.browser.contents)
+        self.assertFalse('John Anthony Tester' in self.browser.contents)
         self.browser.getControl(name="searchtype").value = ['reg_number']
         self.browser.getControl(name="searchterm").value = '1234'
         self.browser.getControl("Search").click()
-        self.assertTrue('John Tester' in self.browser.contents)
+        self.assertTrue('John Anthony Tester' in self.browser.contents)
         # ... and not via his application_number ...
         self.browser.getControl(name="searchtype").value = ['applicant_id']
@@ -256,5 +257,5 @@
             name="searchterm").value = self.applicant.application_number
         self.browser.getControl("Search").click()
-        self.assertFalse('John Tester' in self.browser.contents)
+        self.assertFalse('John Anthony Tester' in self.browser.contents)
         # ... but ia his applicant_id ...
         self.browser.getControl(name="searchtype").value = ['applicant_id']
@@ -262,10 +263,10 @@
             name="searchterm").value = self.applicant.applicant_id
         self.browser.getControl("Search").click()
-        self.assertTrue('John Tester' in self.browser.contents)
+        self.assertTrue('John Anthony Tester' in self.browser.contents)
         # ... and via his email
         self.browser.getControl(name="searchtype").value = ['email']
         self.browser.getControl(name="searchterm").value = 'xx@yy.zz'
         self.browser.getControl("Search").click()
-        self.assertTrue('John Tester' in self.browser.contents)
+        self.assertTrue('John Anthony Tester' in self.browser.contents)
         return
 
@@ -759,5 +760,5 @@
         # Applicant is payee of the payment ticket.
         self.assertEqual(
-            IPaymentWebservice(payment).display_fullname, 'John Tester')
+            IPaymentWebservice(payment).display_fullname, 'John Anthony Tester')
         self.assertEqual(
             IPaymentWebservice(payment).id, self.applicant.applicant_id)