Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/interfaces.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/interfaces.py	(revision 9564)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/interfaces.py	(revision 9567)
@@ -20,5 +20,5 @@
 from waeup.kofa.schema import TextLineChoice
 from waeup.kofa.interfaces import SimpleKofaVocabulary, academic_sessions_vocab
-from waeup.kofa.schema import FormattedDate
+from waeup.kofa.schema import FormattedDate, PhoneNumber
 from waeup.kofa.schoolgrades import ResultEntryField
 from waeup.kofa.students.vocabularies import nats_vocab
@@ -393,5 +393,11 @@
         required = False,
         readonly = False,
-        description = _(u'Please provide email address and/or phone number.'),
+        )
+
+    next_kin_phone = PhoneNumber(
+        title = _(u'Next of Kin Phone'),
+        description = u'',
+        required = False,
+        readonly = False,
         )
 
@@ -457,7 +463,15 @@
         required = True,
         readonly = False,
-        description = _(u'Please provide email address and/or phone number.'),
-        )
-
+        )
+
+    next_kin_phone = PhoneNumber(
+        title = _(u'Next of Kin Phone'),
+        description = u'',
+        required = True,
+        readonly = False,
+        )
+
+INigeriaStudentPersonalEdit['perm_address'].order = INigeriaStudentPersonal[
+    'perm_address'].order
 INigeriaStudentPersonalEdit['next_kin_name'].order = INigeriaStudentPersonal[
     'next_kin_name'].order
@@ -466,6 +480,6 @@
 INigeriaStudentPersonalEdit['next_kin_address'].order = INigeriaStudentPersonal[
     'next_kin_address'].order
-INigeriaStudentPersonalEdit['perm_address'].order = INigeriaStudentPersonal[
-    'perm_address'].order
+INigeriaStudentPersonalEdit['next_kin_phone'].order = INigeriaStudentPersonal[
+    'next_kin_phone'].order
 
 class INigeriaStudentStudyCourse(IStudentStudyCourse):
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py	(revision 9564)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py	(revision 9567)
@@ -250,4 +250,6 @@
         self.browser.getControl(name="form.next_kin_relation").value = 'mother'
         self.browser.getControl(name="form.next_kin_address").value = 'sweet home'
+        self.browser.getControl(name="form.next_kin_phone.country").value = ['+234']
+        self.browser.getControl(name="form.next_kin_phone.ext").value = '45678'
         self.browser.getControl("Save").click()
         self.assertMatches('...Form has been saved...',
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py	(revision 9564)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_export.py	(revision 9567)
@@ -55,5 +55,5 @@
             'hq_school,hq_session,hq_type,is_staff,lastname,lga,'
             'marit_stat,matric_number,middlename,nationality,'
-            'next_kin_address,next_kin_name,next_kin_relation,'
+            'next_kin_address,next_kin_name,next_kin_phone,next_kin_relation,'
             'nysc_lga,nysc_location,nysc_year,officer_comment,'
             'perm_address,personal_updated,phone,reg_number,'
@@ -64,5 +64,5 @@
             '"[(\'visual_art\', \'A1\')]",0,my clr code,1981-02-04#,,,'
             'anna@sample.com,,,,,,,,,,,Anna,,,,,"[(\'visual_art\', \'A1\')]"'
-            ',,,,,,,,,,,,,,,,Tester,,,234,M.,NG,,,,,,,,'
+            ',,,,,,,,,,,,,,,,Tester,,,234,M.,NG,,,,,,,,,'
             '"Studentroad 21\nLagos 123456\n",,+234-123-12345#,123,,,,,'
             '"[(\'visual_art\', \'A1\')]",,f,A111111,0,,created,'