Index: main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py	(revision 9569)
+++ main/waeup.uniben/trunk/src/waeup/uniben/interswitch/tests.py	(revision 9570)
@@ -108,13 +108,15 @@
         self.browser.getControl(name="form.p_category").value = ['schoolfee']
         self.browser.getControl("Create ticket").click()
-        # Next session payment can't be made ...
-        self.assertMatches(
-            '...You have not yet paid your current/active session...',
-            self.browser.contents)
-        # current session payment must be approved first.
-        self.student['payments'][current_payment_key].approve()
-        self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
-        self.browser.getControl("Create ticket").click()
+
+        ## Next session payment can't be made ...
+        #self.assertMatches(
+        #    '...You have not yet paid your current/active session...',
+        #    self.browser.contents)
+        ## current session payment must be approved first.
+        #self.student['payments'][current_payment_key].approve()
+        #self.browser.open(self.payments_path + '/addop')
+        #self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        #self.browser.getControl("Create ticket").click()
+
         ctrl = self.browser.getControl(name='val_id')
         value = ctrl.options[1]
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 9569)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 9570)
@@ -296,11 +296,15 @@
         self.browser.getControl(name="form.p_category").value = ['schoolfee']
         self.browser.getControl("Create ticket").click()
-        self.assertMatches('...You have not yet paid your current/active session...',
-                           self.browser.contents)
-        # Ok, let's pay the first schoolfee ticket.
-        schoolfee_ticket.approve()
-        self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['schoolfee']
-        self.browser.getControl("Create ticket").click()
+
+
+        #self.assertMatches('...You have not yet paid your current/active session...',
+        #                   self.browser.contents)
+        ## Ok, let's pay the first schoolfee ticket.
+        #schoolfee_ticket.approve()
+        #self.browser.open(self.payments_path + '/addop')
+        #self.browser.getControl(name="form.p_category").value = ['schoolfee']
+        #self.browser.getControl("Create ticket").click()
+
+
         self.assertMatches('...ticket created...',
                            self.browser.contents)
@@ -430,16 +434,20 @@
 
         IWorkflowState(self.student).setState('returning')
-        error, payment = utils.setPaymentDetails('schoolfee',
-            self.student, None, None)
-        self.assertTrue(
-            u'You have not yet paid your current/active session.' in error)
-        # Ok, that means we have to add paid payment ticket first.
-        payment = createObject('waeup.StudentOnlinePayment')
-        payment.p_category = u'schoolfee'
-        payment.p_session = self.student.current_session
-        payment.p_item = u'My Certificate'
-        payment.p_id = u'anyid'
-        payment.p_state = u'paid'
-        self.student['payments']['anykey'] = payment
+
+
+        #error, payment = utils.setPaymentDetails('schoolfee',
+        #    self.student, None, None)
+        #self.assertTrue(
+        #    u'You have not yet paid your current/active session.' in error)
+        ## Ok, that means we have to add paid payment ticket first.
+        #payment = createObject('waeup.StudentOnlinePayment')
+        #payment.p_category = u'schoolfee'
+        #payment.p_session = self.student.current_session
+        #payment.p_item = u'My Certificate'
+        #payment.p_id = u'anyid'
+        #payment.p_state = u'paid'
+        #self.student['payments']['anykey'] = payment
+
+
         error, payment = utils.setPaymentDetails('schoolfee',
             self.student, None, None)
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py	(revision 9569)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/utils.py	(revision 9570)
@@ -146,12 +146,14 @@
                     if academic_session == None:
                         return _(u'Session configuration object is not available.'), None
+
                     # Students are only allowed to pay for the next session
                     # if current session payment
                     # has really been made, i.e. payment object exists.
-                    if not self._paymentMade(
-                        student, student.current_session):
-                        return _('You have not yet paid your current/active' +
-                                 ' session. Please use the previous session' +
-                                 ' payment form first.'), None
+                    #if not self._paymentMade(
+                    #    student, student.current_session):
+                    #    return _('You have not yet paid your current/active' +
+                    #             ' session. Please use the previous session' +
+                    #             ' payment form first.'), None
+
                     if student.is_foreigner:
                         amount = getattr(certificate, 'school_fee_4', 0.0)
@@ -166,12 +168,14 @@
                     if academic_session == None:
                         return _(u'Session configuration object is not available.'), None
+
                     # Students are only allowed to pay for the next session
                     # if current session payment has really been made,
                     # i.e. payment object exists and is paid.
-                    if not self._paymentMade(
-                        student, student.current_session):
-                        return _('You have not yet paid your current/active' +
-                                 ' session. Please use the previous session' +
-                                 ' payment form first.'), None
+                    #if not self._paymentMade(
+                    #    student, student.current_session):
+                    #    return _('You have not yet paid your current/active' +
+                    #             ' session. Please use the previous session' +
+                    #             ' payment form first.'), None
+
                     if student.is_foreigner:
                         amount = getattr(certificate, 'school_fee_4', 0.0)